 /*------------------------------------------------------------------------
    File        : customer
    Syntax      : 
    Author(s)   : Administrator
    Created     : Mon May 25 09:52:02 PDT 2015
    Notes       : 
  ----------------------------------------------------------------------*/
  
@program FILE(name="customer.cls", module="AppServer").
@openapi.openedge.export FILE(type="REST", executionMode="singleton", useReturnValue="false", writeDataSetBeforeImage="false").
@progress.service.resource FILE(name="customer", URI="/customer", schemaName="dsCustomer", schemaFile="pug/AppServer/customer.i").

USING Progress.Lang.*.
USING OpenEdge.BusinessLogic.BusinessEntity.

BLOCK-LEVEL ON ERROR UNDO, THROW.

CLASS customer INHERITS BusinessEntity:
	/*------------------------------------------------------------------------------
			Purpose:                                                                      
			Notes:                                                                        
	------------------------------------------------------------------------------*/
	
	{"customer.i"}
	
	DEFINE DATA-SOURCE srcCustomer FOR sports2000.Customer.
    
	/*------------------------------------------------------------------------------
            Purpose:                                                                      
            Notes:                                                                        
    ------------------------------------------------------------------------------*/
    CONSTRUCTOR PUBLIC customer():
    	
    	DEFINE VAR hDataSourceArray AS HANDLE NO-UNDO EXTENT 1.
        DEFINE VAR cSkipListArray AS CHAR NO-UNDO EXTENT 1.
        
        SUPER (DATASET dsCustomer:HANDLE).
        
        /* Data Source for each table in dataset. Should be in table order as defined 
     	   in DataSet */     
     	hDataSourceArray[1] =  DATA-SOURCE srcCustomer:HANDLE.
     	
     	     	
     	/* Skip-list entry for each table in dataset. Should be in temp-table order 
           as defined in DataSet */
        /* Each skip-list entry is a comma-separated list of field names, to be
 	       ignored in create stmt */
     	    
     	cSkipListArray[1] = "".
     	
     	
     	THIS-OBJECT:ProDataSource = hDataSourceArray.
        THIS-OBJECT:SkipList = cSkipListArray.
     	        
    END CONSTRUCTOR.
    	
    /*------------------------------------------------------------------------------
            Purpose:  Get one or more records, based on a filter string                                                                     
            Notes:                                                                        
    ------------------------------------------------------------------------------*/
    @openapi.openedge.export(type="REST", useReturnValue="false", writeDataSetBeforeImage="false").
    @progress.service.resourceMapping(type="REST", operation="read", URI="?custNum=~{custNum~}", alias="", mediaType="application/json"). 
    METHOD PUBLIC VOID Readcustomer(
    		INPUT custNum AS DECIMAL, 
    		OUTPUT DATASET dsCustomer):
    	
    	DEFINE VARIABLE filter AS CHARACTER NO-UNDO.
    	
    	IF custNum GT 0 THEN
    	  ASSIGN filter = "WHERE custNum EQ " + STRING(custNum). 
    	
    	SUPER:ReadData(filter).
    	      
    END METHOD.
	  
    /*------------------------------------------------------------------------------
            Purpose: Create one or more new records                                                               
            Notes:                                                                        
    ------------------------------------------------------------------------------*/  
    @openapi.openedge.export(type="REST", useReturnValue="false", writeDataSetBeforeImage="false").
    @progress.service.resourceMapping(type="REST", operation="create", URI="", alias="", mediaType="application/json").
    METHOD PUBLIC VOID Createcustomer(INPUT-OUTPUT DATASET dsCustomer):    		
    	       
        SUPER:CreateData(DATASET dsCustomer BY-REFERENCE).
              
    END METHOD.    
	
    /*------------------------------------------------------------------------------
            Purpose:  Update one or more records                                                                  
            Notes:                                                                        
    ------------------------------------------------------------------------------*/
    @openapi.openedge.export(type="REST", useReturnValue="false", writeDataSetBeforeImage="false").
    @progress.service.resourceMapping(type="REST", operation="update", URI="", alias="", mediaType="application/json").
    METHOD PUBLIC VOID Updatecustomer(INPUT-OUTPUT DATASET dsCustomer):    		
	
        SUPER:UpdateData(DATASET dsCustomer BY-REFERENCE).
              
    END METHOD.
	
    /*------------------------------------------------------------------------------
            Purpose:    Delete a record                                                               
            Notes:                                                                        
    ------------------------------------------------------------------------------*/
    @openapi.openedge.export(type="REST", useReturnValue="false", writeDataSetBeforeImage="false").
    @progress.service.resourceMapping(type="REST", operation="delete", URI="", alias="", mediaType="application/json").
    METHOD PUBLIC VOID Deletecustomer(INPUT-OUTPUT DATASET dsCustomer):     		       
	
	   FOR EACH ttCustomer TRANSACTION:
           FIND FIRST Customer EXCLUSIVE-LOCK WHERE Customer.CustNum EQ ttCustomer.CustNum.
	       FOR EACH Order EXCLUSIVE-LOCK WHERE Order.CustNum EQ ttCustomer.CustNum:
	           DELETE Order.
	       END.
	       DELETE Customer.
	   END.

    END METHOD.
    
END CLASS.
