(function() {

    'use strict';

    angular.module('myApp', [
        'ionic',
        'ionic.rating',
        'myApp.home',
        'myApp.customer',
        'myApp.feedback',
        'myApp.models.customer',
        'myApp.models.order',
        'myApp.models.feedback'
    ]).
    constant('endpointUrl', 'http://192.168.1.4:8810/pug').
    config(function($stateProvider, $httpProvider, $urlRouterProvider) {

        $stateProvider
            .state('app', {
                url: "",
                abstract: true,
                templateUrl: "js/app.html"
            });

        $urlRouterProvider.otherwise("/home");

    }).
    controller('MainNavCtrl', function($ionicSideMenuDelegate) {
        var mainNavCtrl = this;
        mainNavCtrl.showSideBar = function() {
            $ionicSideMenuDelegate.toggleLeft();
        }
    }).
    run(function($rootScope, $ionicLoading){
        $rootScope.$on('$stateChangeStart', function() {
            $ionicLoading.show({
                template: 'Loading...'
            });
        });
        $rootScope.$on('$stateChangeSuccess', function() {
            $ionicLoading.hide();
        });

    });

})();