(function() {

    'use strict';

    angular.module('myApp.models.customer', [])
        .factory('CustomerSvc', function($http, endpointUrl) {
            return {
                loadCustomer: function(custNum) {
                    return $http.get(endpointUrl + '/rest/pugService/customer',
                        {params: {custNum: custNum}}).then(function(response) {
                            return response.data.dsCustomer.ttCustomer[0];
                        });
                },
                loadCustomers: function(lastGUID) {
                    return $http.get(endpointUrl + '/rest/pugService/customer',
                                        {params: {lastGUID: lastGUID}}).then(function(response) {
                        return response.data.dsCustomer.ttCustomer;
                    });
                },
                deleteCustomer: function(customer) {
                    var prepDataSet = {dsCustomer: {ttCustomer: [customer]}};
                    return $http({ url: endpointUrl + '/rest/pugService/customer',
                        method: 'DELETE',
                        data: prepDataSet,
                        headers: {"Content-Type": "application/json;charset=utf-8"}
                    });
                }
            }
        });

})();